/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CustomerMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CustomerMutable{}

// CustomerMutable struct for CustomerMutable
type CustomerMutable struct {
	Name string `json:"name"`
	ContactInfo ContactInfo `json:"contact_info"`
	Active *bool `json:"active,omitempty"`
	BillingInfo *string `json:"billing_info,omitempty"`
}

// NewCustomerMutable instantiates a new CustomerMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCustomerMutable(name string, contactInfo ContactInfo) *CustomerMutable {
	this := CustomerMutable{}
	this.Name = name
	this.ContactInfo = contactInfo
	return &this
}

// NewCustomerMutableWithDefaults instantiates a new CustomerMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCustomerMutableWithDefaults() *CustomerMutable {
	this := CustomerMutable{}
	return &this
}

// GetName returns the Name field value
func (o *CustomerMutable) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CustomerMutable) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CustomerMutable) SetName(v string) {
	o.Name = v
}

// GetContactInfo returns the ContactInfo field value
func (o *CustomerMutable) GetContactInfo() ContactInfo {
	if o == nil {
		var ret ContactInfo
		return ret
	}

	return o.ContactInfo
}

// GetContactInfoOk returns a tuple with the ContactInfo field value
// and a boolean to check if the value has been set.
func (o *CustomerMutable) GetContactInfoOk() (*ContactInfo, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactInfo, true
}

// SetContactInfo sets field value
func (o *CustomerMutable) SetContactInfo(v ContactInfo) {
	o.ContactInfo = v
}

// GetActive returns the Active field value if set, zero value otherwise.
func (o *CustomerMutable) GetActive() bool {
	if o == nil || IsNil(o.Active) {
		var ret bool
		return ret
	}
	return *o.Active
}

// GetActiveOk returns a tuple with the Active field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CustomerMutable) GetActiveOk() (*bool, bool) {
	if o == nil || IsNil(o.Active) {
		return nil, false
	}
	return o.Active, true
}

// HasActive returns a boolean if a field has been set.
func (o *CustomerMutable) HasActive() bool {
	if o != nil && !IsNil(o.Active) {
		return true
	}

	return false
}

// SetActive gets a reference to the given bool and assigns it to the Active field.
func (o *CustomerMutable) SetActive(v bool) {
	o.Active = &v
}

// GetBillingInfo returns the BillingInfo field value if set, zero value otherwise.
func (o *CustomerMutable) GetBillingInfo() string {
	if o == nil || IsNil(o.BillingInfo) {
		var ret string
		return ret
	}
	return *o.BillingInfo
}

// GetBillingInfoOk returns a tuple with the BillingInfo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CustomerMutable) GetBillingInfoOk() (*string, bool) {
	if o == nil || IsNil(o.BillingInfo) {
		return nil, false
	}
	return o.BillingInfo, true
}

// HasBillingInfo returns a boolean if a field has been set.
func (o *CustomerMutable) HasBillingInfo() bool {
	if o != nil && !IsNil(o.BillingInfo) {
		return true
	}

	return false
}

// SetBillingInfo gets a reference to the given string and assigns it to the BillingInfo field.
func (o *CustomerMutable) SetBillingInfo(v string) {
	o.BillingInfo = &v
}

func (o CustomerMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CustomerMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["contact_info"] = o.ContactInfo
	if !IsNil(o.Active) {
		toSerialize["active"] = o.Active
	}
	if !IsNil(o.BillingInfo) {
		toSerialize["billing_info"] = o.BillingInfo
	}
	return toSerialize, nil
}

type NullableCustomerMutable struct {
	value *CustomerMutable
	isSet bool
}

func (v NullableCustomerMutable) Get() *CustomerMutable {
	return v.value
}

func (v *NullableCustomerMutable) Set(val *CustomerMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableCustomerMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableCustomerMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCustomerMutable(val *CustomerMutable) *NullableCustomerMutable {
	return &NullableCustomerMutable{value: val, isSet: true}
}

func (v NullableCustomerMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCustomerMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


